



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java8新特性之三：Stream API</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java8新特性之三：Stream API</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 12:45:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Java8的两个重大改变，一个是Lambda表达式，另一个就是本节要讲的Stream API表达式。Stream 是Java8中处理集合的关键抽象概念，它可以对集合进行非常复杂的查找、过滤、筛选等操作，在新版的JPA中，也已经加入了Stream。如：</p>
<div>
<pre class="prettyprint linenums"> @Query("select u from User u")<br />
 Stream&lt;User&gt; findAllByCustomQueryAndStream();

 Stream&lt;User&gt; readAllByFirstnameNotNull();

 @Query("select u from User u")<br />
 Stream&lt;User&gt; streamAllPaged(Pageable pageable);</pre>
</div>
<p>Stream API给我们操作集合带来了强大的功用，同时Stream API操作简单，容易上手。</p>
<h2>1、Stream的操作步骤</h2>
<p>Stream有如下三个操作步骤：</p>
<p><strong>一、创建Stream</strong></p>
<p>从一个数据源，如集合、数组中获取流。</p>
<p><strong>二、中间操作</strong></p>
<p>一个操作的中间链，对数据源的数据进行操作。</p>
<p><strong>三、终止操作</strong></p>
<p>一个终止操作，执行中间操作链，并产生结果。</p>
<p>要注意的是，对流的操作完成后需要进行关闭操作（或者用JAVA7的try-with-resources）。</p>
<p>举个简单的例子：</p>
<p>假设有一个Person类和一个Person列表，现在有两个需求：1）找到年龄大于18岁的人并输出；2）找出所有中国人的数量。</p>
<div>
<pre class="prettyprint linenums"> @Data<br />
 class Person {<br />
     private String name;<br />
     private Integer age;<br />
     private String country;<br />
     private char sex;

     public Person(String name, Integer age, String country, char sex) {<br />
         this.name = name;<br />
         this.age = age;<br />
         this.country = country;<br />
         this.sex = sex;<br />
     }<br />
 }</pre>
</div>
<div>
<pre class="prettyprint linenums"> List&lt;Person&gt; personList = new ArrayList&lt;&gt;();<br />
 personList.add(new Person("欧阳雪",18,"中国",'F'));<br />
 personList.add(new Person("Tom",24,"美国",'M'));<br />
 personList.add(new Person("Harley",22,"英国",'F'));<br />
 personList.add(new Person("向天笑",20,"中国",'M'));<br />
 personList.add(new Person("李康",22,"中国",'M'));<br />
 personList.add(new Person("小梅",20,"中国",'F'));<br />
 personList.add(new Person("何雪",21,"中国",'F'));<br />
 personList.add(new Person("李康",22,"中国",'M'));</pre>
</div>
<p>在JDK8以前，我们可以通过遍历列表来完成。但是在有了Stream API后，可以这样来实现：</p>
<div>
<pre class="prettyprint linenums">  public static void main(String[] args) {

     // 1）找到年龄大于18岁的人并输出；<br />
     personList.stream().filter((p) -&gt; p.getAge() &gt; 18).forEach(System.out::println);

     System.out.println("-------------------------------------------");

     // 2）找出所有中国人的数量<br />
     long chinaPersonNum = personList.stream().filter((p) -&gt; p.getCountry().equals("中国")).count();<br />
     System.out.println("中国人有：" + chinaPersonNum + "个");<br />
 }</pre>
</div>
<p>输出结果：</p>
<div>
<p>Person(name=Tom, age=24, country=美国, sex=M)<br />Person(name=Harley, age=22, country=英国, sex=F)<br />Person(name=向天笑, age=20, country=中国, sex=M)<br />Person(name=李康, age=22, country=中国, sex=M)<br />Person(name=小梅, age=20, country=中国, sex=F)<br />Person(name=何雪, age=21, country=中国, sex=F)<br />Person(name=李康, age=22, country=中国, sex=M)<br />-------------------------------------------<br />中国人有：6</p>
</div>
<p>在这个例子中，personList.stream()是创建流，filter()属于中间操作，forEach、count()是终止操作。</p>
<h2>2、Stream中间操作--筛选与切片</h2>
<ul><li>filter：接收Lambda，从流中排除某些操作；</li>
<li>limit：截断流，使其元素不超过给定对象</li>
<li>skip(n)：跳过元素，返回一个扔掉了前n个元素的流，若流中元素不足n个，则返回一个空流，与limit(n)互补</li>
<li>distinct：筛选，通过流所生成元素的hashCode()和equals()去除重复元素。</li></ul>
<h3><strong>2.1 limit举例</strong></h3>
<p>需求，从Person列表中取出两个女性。</p>
<div>
<pre class="prettyprint linenums"> personList.stream().filter((p) -&gt; p.getSex() == 'F').limit(2).forEach(System.out::println);</pre>
</div>
<p>输出结果为：</p>
<div>
<pre class="prettyprint linenums">Person(name=欧阳雪, age=18, country=中国, sex=F)<br />
Person(name=Harley, age=22, country=英国, sex=F)</pre>
</div>
<h3>2.2 skip举例</h3>
<p>从Person列表中从第2个女性开始，取出所有的女性。</p>
<div>
<pre class="prettyprint linenums"> personList.stream().filter((p) -&gt; p.getSex() == 'F').skip(1).forEach(System.out::println);</pre>
</div>
<p>输出结果为：</p>
<div>
<pre class="prettyprint linenums">Person(name=Harley, age=22, country=英国, sex=F)<br />
Person(name=小梅, age=20, country=中国, sex=F)<br />
Person(name=何雪, age=21, country=中国, sex=F)</pre>
</div>
<h3>2.3 distinct举例</h3>
<div>
<pre class="prettyprint linenums"> personList.stream().filter((p) -&gt; p.getSex() == 'M').distinct().forEach(System.out::println);</pre>
</div>
<p>输出结果为：</p>
<div>
<pre class="prettyprint linenums">Person(name=Tom, age=24, country=美国, sex=M)<br />
Person(name=向天笑, age=20, country=中国, sex=M)<br />
Person(name=李康, age=22, country=中国, sex=M)</pre>
</div>
<p>男性中有两个李康，去除掉了一个重复的。</p>
<h2>3、Stream中间操作--映射</h2>
<ul><li>map--接收Lambda，将元素转换成其他形式或提取信息。接收一个函数作为参数，该函数会被应用到每个元素上，并将其映射成一个新的元素。</li>
<li>flatMap--接收一个函数作为参数，将流中的每个值都换成另一个流，然后把所有流连接成一个流</li></ul>
<h3>3.1&nbsp;map举例</h3>
<p>例1：比如，我们用一个PersonCountry类来接收所有的国家信息：</p>
<div>
<pre class="prettyprint linenums"> @Data<br />
 class PersonCountry {<br />
     private String country;<br />
 }

 personList.stream().map((p) -&gt; {<br />
        PersonCountry personName = new PersonCountry();<br />
        personName.setCountry(p.getCountry());<br />
        return personName;<br />
 }).distinct().forEach(System.out::println);</pre>
</div>
<p>输出结果为：</p>
<div>
<pre class="prettyprint linenums">PersonName(country=中国)<br />
PersonName(country=美国)<br />
PersonName(country=英国)</pre>
</div>
<p>例2：假如有一个字符列表，需要提出每一个字符</p>
<div>
<pre class="prettyprint linenums"> List&lt;String&gt; list = Arrays.asList("aaa","bbb","ccc","ddd","ddd");</pre>
</div>
<p>代码如下：</p>
<p>根据字符串获取字符方法：</p>
<div>
<pre class="prettyprint linenums"> public static Stream&lt;Character&gt; getCharacterByString(String str) {

     List&lt;Character&gt; characterList = new ArrayList&lt;&gt;();

     for (Character character : str.toCharArray()) {<br />
         characterList.add(character);<br />
     }

     return characterList.stream();<br />
 }</pre>
</div>
<div>
<pre class="prettyprint linenums"> List&lt;String&gt; list = Arrays.asList("aaa","bbb","ccc","ddd","ddd");

 final Stream&lt;Stream&lt;Character&gt;&gt; streamStream<br />
         = list.stream().map(TestStreamAPI::getCharacterByString);<br />
 streamStream.forEach(System.out::println);</pre>
</div>
<p>运行结果：</p>
<div>
<pre class="prettyprint linenums">java.util.stream.ReferencePipeline$Head@3f91beef<br />
java.util.stream.ReferencePipeline$Head@1a6c5a9e<br />
java.util.stream.ReferencePipeline$Head@37bba400<br />
java.util.stream.ReferencePipeline$Head@179d3b25<br />
java.util.stream.ReferencePipeline$Head@254989ff</pre>
</div>
<p>从输出结果及返回结果类型（Stream&lt;Stream&lt;Character&gt;&gt;）可以看出这是一个流中流，要想打印出我们想要的结果，需要对流中的每个流进行打印：</p>
<div>
<pre class="prettyprint linenums">streamStream.forEach(sm -&gt; sm.forEach(System.out::print));</pre>
</div>
<p>运行结果为：</p>
<div>
<pre class="prettyprint linenums">aaabbbcccdddddd</pre>
</div>
<p>但我们希望的是返回的是一个流，而不是一个包含了多个流的流，而flatMap可以帮助我们做到这一点。</p>
<h3>3.2&nbsp;flatMap举例</h3>
<p>改写上面的方法，将map改成flatMap:</p>
<div>
<pre class="prettyprint linenums"> final Stream&lt;Character&gt; characterStream = list.stream().flatMap(TestStreamAPI::getCharacterByString);<br />
 characterStream.forEach(System.out::print);</pre>
</div>
<p>运行结果为：</p>
<div>
<pre class="prettyprint linenums">aaabbbcccdddddd</pre>
</div>
<h3>3.3&nbsp;map和flatMap的图解</h3>
<p>map图解：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1651332/201904/1651332-20190420113433598-2127159072.png" /></p>
<p>map在接收到流后，直接将Stream放入到一个Stream中，最终整体返回一个包含了多个Stream的Stream。</p>
<p>flatMap图解：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1651332/201904/1651332-20190420113649811-1005854724.png" /></p>
<p>flatMap在接收到Stream后，会将接收到的Stream中的每个元素取出来放入一个Stream中，最后将一个包含多个元素的Stream返回。</p>
<p>ps：图画得丑，将就一下。</p>
<h2>4、Stream中间操作--排序</h2>
<ul><li>sorted()--自然排序(Comparable)</li>
<li>sorted(Comparator com)--定制排序（Comparator）</li></ul>
<p>自然排序比较好理解，这里只讲一下定制排序，对前面的personList按年龄从小到大排序,年龄相同，则再按姓名排序：</p>
<div>
<pre class="prettyprint linenums"> final Stream&lt;Person&gt; sorted = personList.stream().sorted((p1, p2) -&gt; {

     if (p1.getAge().equals(p2.getAge())) {<br />
         return p1.getName().compareTo(p2.getName());<br />
     } else {<br />
         return p1.getAge().compareTo(p2.getAge());<br />
     }<br />
 });<br />
 sorted.forEach(System.out::println);</pre>
</div>
<p>运行结果：</p>
<div>
<pre class="prettyprint linenums">Person(name=欧阳雪, age=18, country=中国, sex=F)<br />
Person(name=向天笑, age=20, country=中国, sex=M)<br />
Person(name=小梅, age=20, country=中国, sex=F)<br />
Person(name=何雪, age=21, country=中国, sex=F)<br />
Person(name=Harley, age=22, country=英国, sex=F)<br />
Person(name=李康, age=22, country=中国, sex=M)<br />
Person(name=李康, age=22, country=中国, sex=M)<br />
Person(name=Tom, age=24, country=美国, sex=M)</pre>
</div>
<h2>5、终止操作--查找与匹配</h2>
<ul><li>allMatch--检查是否匹配所有元素</li>
<li>anyMatch--检查是否至少匹配一个元素</li>
<li>noneMatch--检查是否没有匹配所有元素</li>
<li>findFirst--返回第一个元素</li>
<li>findAny--返回当前流中的任意元素</li>
<li>count--返回流中元素的总个数</li>
<li>max--返回流中最大值</li>
<li>min--返回流中最小值</li></ul>
<p>这些方面在Stream类中都有说明，这里不一一举例，只对allMatch、max各举一例进行说明。</p>
<h3>4.1&nbsp;allMatch</h3>
<p>判断personList中的人是否都是成年人：</p>
<div>
<pre class="prettyprint linenums"> final boolean adult = personList.stream().allMatch(p -&gt; p.getAge() &gt;= 18);<br />
 System.out.println("是否都是成年人：" + adult);

 final boolean chinaese = personList.stream().allMatch(p -&gt; p.getCountry().equals("中国"));<br />
 System.out.println("是否都是中国人：" + chinaese);</pre>
</div>
<p>运行结果：</p>
<div>
<pre class="prettyprint linenums">是否都是成年人：true<br />
是否都是中国人：false</pre>
</div>
<h3>4.1&nbsp;max&nbsp;min</h3>
<div>
<pre class="prettyprint linenums"> final Optional&lt;Person&gt; maxAge = personList.stream().max((p1, p2) -&gt; p1.getAge().compareTo(p2.getAge()));<br />
 System.out.println("年龄最大的人信息：" + maxAge.get());

 final Optional&lt;Person&gt; minAge = personList.stream().min((p1, p2) -&gt; p1.getAge().compareTo(p2.getAge()));<br />
 System.out.println("年龄最小的人信息：" + minAge.get());</pre>
</div>
<p>运行结果：</p>
<div>
<pre class="prettyprint linenums">年龄最大的人信息：Person(name=Tom, age=24, country=美国, sex=M)<br />
年龄最小的人信息：Person(name=欧阳雪, age=18, country=中国, sex=F)</pre>
</div>
<h2>5、归约</h2>
<p>Stream API的归约操作可以将流中元素反复结合起来，得到一个值，有：</p>
<div>
<pre class="prettyprint linenums"> Optional&lt;T&gt; reduce(BinaryOperator&lt;T&gt; accumulator);

 T reduce(T identity, BinaryOperator&lt;T&gt; accumulator);

 &lt;U&gt; U reduce(U identity,<br />
                  BiFunction&lt;U, ? super T, U&gt; accumulator,<br />
                  BinaryOperator&lt;U&gt; combiner);</pre>
</div>
<h3>5.1 求一个1到100的和</h3>
<div>
<pre class="prettyprint linenums"> List&lt;Integer&gt; integerList = new ArrayList&lt;&gt;(100);<br />
 for(int i = 1;i &lt;= 100;i++) {<br />
     integerList.add(i);<br />
 }<br />
 final Integer reduce = integerList.stream().reduce(0, (x, y) -&gt; x + y);<br />
 System.out.println("结果为：" + reduce);</pre>
</div>
<div>
<pre class="prettyprint linenums">结果为：5050</pre>
</div>
<p>这个例子用到了reduce第二个方法：T reduce(T identity, BinaryOperator&lt;T&gt; accumulator)</p>
<p>把这个动作拆解一下，其运算步骤模拟如下：</p>
<div>
<pre class="prettyprint linenums">0  (1,2) -&gt; 1 + 2 + 0<br />
3  (3,4) -&gt; 3 + 4 + 3<br />
10 (5,6) -&gt; 5 + 6 + 10<br />
.<br />
.<br />
.</pre>
</div>
<p>其运算步骤是，每次将列表的两个元素相加，并将结果与前一次的两个元素的相加结果进行累加，因此，在开始时，将identity设为0，因为第1个元素和第2个元素在相加的时候，前面还没有元素操作过。</p>
<h3>5.2 求所有人的年龄之和</h3>
<div>
<pre class="prettyprint linenums"> final Optional&lt;Integer&gt; reduce = personList.stream().map(Person::getAge).reduce(Integer::sum);<br />
System.out.println("年龄总和：" + reduce);</pre>
</div>
<div>
<pre class="prettyprint linenums">年龄总和：169</pre>
</div>
<h2>6、收集</h2>
<p>collect：将流转换为其他形式，接收一个Collector接口实现 ，用于给Stream中汇总的方法</p>
<div>
<pre class="prettyprint linenums"> &lt;R, A&gt; R collect(Collector&lt;? super T, A, R&gt; collector);

 &lt;R&gt; R collect(Supplier&lt;R&gt; supplier,<br />
                   BiConsumer&lt;R, ? super T&gt; accumulator,<br />
                   BiConsumer&lt;R, R&gt; combiner);</pre>
</div>
<p>collect不光可以将流转换成其他集合等形式，还可以进行归约等操作，具体实现也很简单，主要是与Collectors类搭配使用。</p>
<h3>6.1 改写3.1 map举例中的的例子，将国家收集起来转换成List</h3>
<div>
<pre class="prettyprint linenums"> final List&lt;String&gt; collect = personList.stream().map(p -&gt; p.getCountry()).distinct().collect(Collectors.toList());<br />
         System.out.println(collect);</pre>
</div>
<p>输出结果：</p>
<div>
<pre class="prettyprint linenums">[中国, 美国, 英国]</pre>
</div>
<h3>6.2 计算出平均年龄</h3>
<div>
<pre class="prettyprint linenums"> final Double collect1 = personList.stream().collect(Collectors.averagingInt(p -&gt; p.getAge()));<br />
2 System.out.println("平均年龄为：" + collect1);</pre>
</div>
<p>输出结果：</p>
<div>
<pre class="prettyprint linenums">平均年龄为：21.125</pre>
</div>
<h3>6.3&nbsp;找出最小年龄、最大年龄</h3>
<div>
<pre class="prettyprint linenums"> final Optional&lt;Integer&gt; maxAge2 = personList.stream().map(Person::getAge).collect(Collectors.maxBy(Integer::compareTo));<br />
 System.out.println(maxAge2.get());</pre>
</div>
<p>最小年龄类型。</p>
<p>还有其他很操作，可以参考java.util.stream.Collectors。</p>
<h2>7&nbsp;注意流的关闭</h2>
<div>
<pre class="prettyprint linenums"> try(final Stream&lt;Integer&gt; integerStream = personList.stream().map(Person::getAge)) {<br />
   final Optional&lt;Integer&gt; minAge = integerStream.collect(Collectors.minBy(Integer::compareTo));<br />
   System.out.println(minAge.get());<br />
}</pre>
</div>
<p>最好将流的操作放到try-with-resources，本章前面内容为了方便，没有放到try-with-resources中。</p>
<h2>8&nbsp;完整测试代码</h2>
<div>
<pre class="prettyprint linenums"> import lombok.Data;<br />
 import java.util.ArrayList;<br />
 import java.util.Arrays;<br />
 import java.util.List;<br />
 import java.util.Optional;<br />
 import java.util.stream.Collectors;<br />
 import java.util.stream.Stream;

 public class TestStreamAPI {

     public static void main(String[] args) {<br />
         List&lt;Person&gt; personList = new ArrayList&lt;&gt;();<br />
         personList.add(new Person("欧阳雪",18,"中国",'F'));<br />
         personList.add(new Person("Tom",24,"美国",'M'));<br />
         personList.add(new Person("Harley",22,"英国",'F'));<br />
         personList.add(new Person("向天笑",20,"中国",'M'));<br />
         personList.add(new Person("李康",22,"中国",'M'));<br />
         personList.add(new Person("小梅",20,"中国",'F'));<br />
         personList.add(new Person("何雪",21,"中国",'F'));<br />
         personList.add(new Person("李康",22,"中国",'M'));

         // 1）找到年龄大于18岁的人并输出；<br />
         personList.stream().filter((p) -&gt; p.getAge() &gt; 18).forEach(System.out::println);

         System.out.println("-------------------------------------------");

         // 2）找出所有中国人的数量<br />
         long chinaPersonNum = personList.stream().filter((p) -&gt; p.getCountry().equals("中国")).count();<br />
         System.out.println("中国人有：" + chinaPersonNum);

         // limit<br />
         personList.stream().filter((p) -&gt; p.getSex() == 'F').limit(2).forEach(System.out::println);<br />
         System.out.println();<br />
         // skip<br />
         personList.stream().filter((p) -&gt; p.getSex() == 'F').skip(1).forEach(System.out::println);

         // distinct<br />
         personList.stream().filter((p) -&gt; p.getSex() == 'M').distinct().forEach(System.out::println);

         // map<br />
         personList.stream().map((p) -&gt; {<br />
             PersonCountry personName = new PersonCountry();<br />
             personName.setCountry(p.getCountry());<br />
             return personName;<br />
         }).distinct().forEach(System.out::println);

         // map2<br />
         List&lt;String&gt; list = Arrays.asList("aaa","bbb","ccc","ddd","ddd");

         final Stream&lt;Stream&lt;Character&gt;&gt; streamStream<br />
                 = list.stream().map(TestStreamAPI::getCharacterByString);<br />
 //        streamStream.forEach(System.out::println);<br />
         streamStream.forEach(sm -&gt; sm.forEach(System.out::print));

         // flatMap<br />
         final Stream&lt;Character&gt; characterStream = list.stream().flatMap(TestStreamAPI::getCharacterByString);<br />
         characterStream.forEach(System.out::print);

         // sort<br />
         final Stream&lt;Person&gt; sorted = personList.stream().sorted((p1, p2) -&gt; {

             if (p1.getAge().equals(p2.getAge())) {<br />
                 return p1.getName().compareTo(p2.getName());<br />
             } else {<br />
                 return p1.getAge().compareTo(p2.getAge());<br />
             }<br />
         });<br />
         sorted.forEach(System.out::println);

         // allMatch<br />
         final Stream&lt;Person&gt; stream = personList.stream();<br />
         final boolean adult = stream.allMatch(p -&gt; p.getAge() &gt;= 18);<br />
         System.out.println("是否都是成年人：" + adult);

         final boolean chinaese = personList.stream().allMatch(p -&gt; p.getCountry().equals("中国"));<br />
         System.out.println("是否都是中国人：" + chinaese);

         // max min<br />
         final Optional&lt;Person&gt; maxAge = personList.stream().max((p1, p2) -&gt; p1.getAge().compareTo(p2.getAge()));<br />
         System.out.println("年龄最大的人信息：" + maxAge.get());

         final Optional&lt;Person&gt; minAge = personList.stream().min((p1, p2) -&gt; p1.getAge().compareTo(p2.getAge()));<br />
         System.out.println("年龄最小的人信息：" + minAge.get());

         // reduce<br />
         List&lt;Integer&gt; integerList = new ArrayList&lt;&gt;(100);<br />
         for(int i = 1;i &lt;= 100;i++) {<br />
             integerList.add(i);<br />
         }<br />
         final Integer reduce = integerList.stream().reduce(0, (x, y) -&gt; x + y);<br />
         System.out.println("结果为：" + reduce);

         final Optional&lt;Integer&gt; totalAge = personList.stream().map(Person::getAge).reduce(Integer::sum);<br />
         System.out.println("年龄总和：" + totalAge);

         // collect<br />
         final List&lt;String&gt; collect = personList.stream().map(p -&gt; p.getCountry()).distinct().collect(Collectors.toList());<br />
         System.out.println(collect);

         final Double collect1 = personList.stream().collect(Collectors.averagingInt(p -&gt; p.getAge()));<br />
         System.out.println("平均年龄为：" + collect1);

         final Optional&lt;Integer&gt; maxAge2 = personList.stream().map(Person::getAge).collect(Collectors.maxBy(Integer::compareTo));<br />
         System.out.println(maxAge2.get());

         try(final Stream&lt;Integer&gt; integerStream = personList.stream().map(Person::getAge)) {<br />
             final Optional&lt;Integer&gt; minAge2 = integerStream.collect(Collectors.minBy(Integer::compareTo));<br />
             System.out.println(minAge2.get());<br />
         }<br />
     }

     public static Stream&lt;Character&gt; getCharacterByString(String str) {

         List&lt;Character&gt; characterList = new ArrayList&lt;&gt;();

         for (Character character : str.toCharArray()) {<br />
             characterList.add(character);<br />
         }

         return characterList.stream();<br />
     }<br />
 }

 @Data<br />
 class PersonCountry {<br />
     private String country;<br />
 }

 @Data<br />
 class Person {<br />
     private String name;<br />
     private Integer age;<br />
     private String country;<br />
     private char sex;

     public Person(String name, Integer age, String country, char sex) {<br />
         this.name = name;<br />
         this.age = age;<br />
         this.country = country;<br />
         this.sex = sex;<br />
     }<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pm1xk9.html">gong server</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy5e329.html">linux配置ftp</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7w7m19.html">同一个解决方案&amp;quot&semi;引用&amp;quot&semi;其他的项目出现感叹号&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn2no6q.html">kindle相关工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvz7zxq.html">第三百零八至三百二十天 how can I 坚持</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1v4j39.html">Java 编译错误：缺少返回语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnjdgj8.html">jQuery获取鼠标事件源（万能）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm70jz9.html">Scala学习笔记之：tuple、array、Map</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pom138.html">window2003远程桌面&OpenCurlyDoubleQuote;已达最大连接数&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxknxxz8.html">delphi 回调函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkeko08.html">如何用js实现自适应，原来只是几行代码的事&lpar;╯&backprime;&Square;&prime;&rpar;╯︵┻━┻</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p2gk38.html">WPF 自定义DataGrid控件样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1mj1zq.html">关于java和c&plus;&plus;中布尔量的比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjo4r9.html">linux之Ubuntu学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlloezeq.html">python-Selenium库的详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rjdno9.html">一名全栈设计师的Mac工具箱（设计&comma;开发&comma;效率）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll7nkxq.html">&lbrack;Oracle&rsqb;PDB Clone 方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwll63k9.html">ABBYY FineReader 12没你想得那么简单</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e7xjk9.html">关于python单方法的类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn7vorq.html">hbase copyTable</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90mx5jn8.html">jQuery匿名函数&dollar;&lpar;function&lpar;&rpar;&lbrace; &rcub;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jllmw8.html">在Web中获取MAC地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zonnlnq.html">解析xml字符串时报&OpenCurlyDoubleQuote;前言中不允许有内容&rdquo;错误。</a>
			</li>
						<li><a href="https://www.batexi.com/a/950kexz8.html">115个Java面试题和答案&mdash;&mdash;终极列表（上）【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdo4z79.html">3d轮播图&mdash;&mdash;类似酷狗的轮播</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgrxj48.html">webpack4：连奏中的进化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me71e6q.html">Spring Boot实战笔记（八）-- Spring高级话题（条件注解&commat;Conditional）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gevoo78.html">计算机网络相关：应用层协议（一）：DNS</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mxz2j8.html">Netty中的EventLoop和线程模型</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj3yl69.html">用R语言进行文本挖掘和主题建模</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
